import re

##############################################################
class Collection:
  def __init__(self):
      self.docs = []            #  list of Documents
      self.dictionary = {}      #  dictionary list of word => list(df => f, no = int)
      self.no2Term = []

  def addDoc(self, docid, tit):
      d = Document(docid, tit)
      self.docs.append(d)
      return d

  def createDictionary(self):
      mapNo = 0
      for d in self.docs:
          for w in d.termFreq:
            if w in self.dictionary:
               self.dictionary[w]['df'] += 1
            else:
               self.dictionary[w]={}
               self.dictionary[w]['df'] = 1
               self.dictionary[w]['no'] = mapNo
               self.no2Term.append(w)
               mapNo += 1
      return None

  def getDf(self,word):
      return self.dictionary[word]['df']

  def getNo(self,word):
      return self.dictionary[word]['no']

  def getTerm(self, i):
      return self.no2Term[i]

#ToBeImplemented
  def printFreqMatrix(self):
    print self.dictionary

##############################################################
class Document:
  def __init__(self, val, tit):
      self.id = val
      self.title = tit
      self.termFreq = {}    # dictionary word => tf

  def addText(self, t, stopw):
#      for w in t.split():
       for w in re.findall(r"[\w'@#]+", t.lower()):
          if len(w) < 1: continue
          if w in self.termFreq:
              self.termFreq[w]['tf'] += 1
          else:
              self.termFreq[w]={}
              self.termFreq[w]['tf']=1

  def getTf(self, w):
      return self.termFreq[w]['tf']

  def getTfIdf(self, w):
      return self.termFreq[w]['tfidf']

  def setTfIdf(self, w, val):
      self.termFreq[w]['tfidf'] = val

##############################################################
#?class IRutil:
# ToBeImplemented
#  function runSVD($dim) {
#  function readS() {
#  function readUt() {
